<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>JavaLocationStrategy xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../apidocs/org/eclipse/papyrus/designer/languages/java/codegen/transformation/JavaLocationStrategy.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*******************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2006 - 2016 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *     Shuai Li (CEA LIST) &lt;shuai.li@cea.fr&gt; - initial API and implementation</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> *******************************************************************************/</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.languages.java.codegen.transformation;
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.common.base.GenUtils;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.common.base.HierarchyLocationStrategy;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.common.profile.Codegen.Project;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.tools.utils.PackageUtil;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.NamedElement;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/codegen/transformation/JavaLocationStrategy.html">JavaLocationStrategy</a> <strong class="jxr_keyword">extends</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/common/base/HierarchyLocationStrategy.html">HierarchyLocationStrategy</a> {
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <em class="jxr_javadoccomment">	 * Return the filename for a given named element.</em>
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <em class="jxr_javadoccomment">	 * @param element</em>
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <em class="jxr_javadoccomment">	 *            a named element</em>
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <em class="jxr_javadoccomment">	 * @return filename for this element</em>
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  	<strong class="jxr_keyword">public</strong> String getFileName(NamedElement element) {
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  		String fileQualifiedName = <strong class="jxr_keyword">super</strong>.getFileName(element);
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  		
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  		org.eclipse.uml2.uml.Package root = PackageUtil.getRootPackage(element);
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  		<strong class="jxr_keyword">if</strong> (fileQualifiedName != <strong class="jxr_keyword">null</strong> &amp;&amp; root != <strong class="jxr_keyword">null</strong> &amp;&amp; GenUtils.hasStereotype(root, Project.<strong class="jxr_keyword">class</strong>)) {
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  			<strong class="jxr_keyword">if</strong> (fileQualifiedName.startsWith(root.getName()) || fileQualifiedName.startsWith(<span class="jxr_string">"/"</span> + root.getName())) {
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  				String fileQualifiedNameWithoutRoot = fileQualifiedName.replaceFirst(root.getName() + <span class="jxr_string">"/"</span>, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  				<strong class="jxr_keyword">return</strong> fileQualifiedNameWithoutRoot;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  			}
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  			
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  			<strong class="jxr_keyword">return</strong> fileQualifiedName;
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  		}
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  		
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  		<strong class="jxr_keyword">return</strong> fileQualifiedName;
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  	}
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016&#x2013;2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
